.686			
.MMX
.model flat, stdcall
option casemap:none

include j:\masm32\include\windows.inc
include j:\masm32\include\kernel32.inc
include j:\masm32\include\masm32.inc

include j:\masm32\macros\macros.asm
include j:\masm32\macros\timers.asm

includelib j:\masm32\lib\kernel32.lib
includelib j:\masm32\lib\masm32.lib


Main        proto

BinSearch proto :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
BInStr proto
BInStrWithLen proto
BMBinSearch proto :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
BMBinSearch2 proto
FJT proto :DWORD,:DWORD,:DWORD,:DWORD
FJT2 proto

.data

align 4

  LOOP_COUNT    EQU	500000
  MINUS_1       EQU 0ffffffffH

  SzBS           db "BinSearch:        ",0
  SzBWL          db "BInStrWithLen:    ",0
  SzBMB          db "BMBinSearch:      ",0
  SzBM2          db "BMBinSearch2:     ",0
  SzBMC          db "FJT by Cresta:    ",0
  SzBMI          db "FJT2 Cresta/IanB: ",0

  ; matchlen 10, sourcelen 50
  ; with optimisations, the Boyer-Moore is now only half as slow as the
  ; word scanner for short searches
  SzMatch1       db "Here it is"
  SzTest1        db "Short test with match string at end: Here it is!",13,10,0
  SzResult1      db 13,10,"Search Test 1 - value expected 37",13,10,0

  ; matchlen 17, sourcelen 1024
  ; deliberately difficult, every position must be tested with this match start
  SzMatch2       db "MMMMMMhardMMMMMMM"
  SzTest2        db 1007 dup ("M"), "MMMMMMhardMMMMMMM", 0
  SzResult2      db 13,10,"Search Test 2 - value expected 1007",13,10,0

  ; matchlen 16, sourcelen 1024
  ; pattern very different from background
  SzMatch3       db "Should be easier"
  SzTest3        db 1008 dup ("M"), "Should be easier", 0
  SzResult3      db 13,10,"Search Test 3 - value expected 1008",13,10,0

  ; matchlen 16, sourcelen 1024
  ; BinSearch seems to have advantage for longer match lengths 
  SzMatch4       db "Many repetitions"
  SzTest4        db 72 dup ("Many repetitio"), "Many repetitions", 0
  SzResult4      db 13,10,"Search Test 4 - value expected 1008",13,10,0

  ; matchlen 16, sourcelen 1024
  ; BinSearch can't seem to take advantage of the earlier match failure 
  SzMatch5       db "Many repetitions"
  SzTest5        db 72 dup ("Many repeatsns"), "Many repetitions", 0
  SzResult5      db 13,10,"Search Test 5 - value expected 1008",13,10,0

  ; matchlen 16, sourcelen 1024
  ; serious disadvantage for Boyer-Moore for this close repeating pattern
  ; as all the repeats must check from the matching end almost to the start
  SzMatch6       db "Many repetitions"
  SzTest6        db 72 dup ("No repetitions"), "Many repetitions", 0
  SzResult6      db 13,10,"Search Test 6 - value expected 1008",13,10,0

  ; matchlen 14, sourcelen 1024
  ; more random text, BInStrWithLen catching up with Boyer-Moore
  SzMatch7       db "no repetitions"
  SzTest7        db "The three algorithms are variations of a Boyer Moore design. "
                 db "The original design BMBinSearch is the most flexible across different search conditions. "
                 db "The two variations BMHBinsearch and SBMBinSearch are respectively a Horspool variation "
                 db "and a simplified variation which perform well depending on the hardware and the "
                 db "patterns being searched. The minimum pattern length is 2 bytes but these algorithms are "
                 db "slower on very short patterns than a classic byte scanner. The algorithms have about a "
                 db "300 character penalty at startup as they must construct a table so for either very "
                 db "short patterns or short data it is more efficient to use a byte scanner. "
                 db "The three algorithms are variations of a Boyer Moore design. "
                 db "The original design BMBinSearch is the most flexible across different search conditions. "
                 db "The two variations BMHBinsearch and SBMBinSearch are respectively a Horspool variation "
                 db "and a simplified variation which perform well depending on the hardware and the "
                 db "patterns being searched. Basic text, few or no repetitions", 0
  SzResult7      db 13,10,"Search Test 7 - value expected 1009",13,10,0

.data?

  ShiftTable     BYTE 256 DUP (?)

.code

Start:
	Invoke	Main
	Invoke	ExitProcess, 0


Main    proc

        push    ebx
        push    edi
        mov     eax, input("Please terminate any high-priority tasks and press ENTER to begin...")
        print   chr$(13,10,13,10,"String search tests:",13,10,13,10)


        print   addr SzResult1

        print   addr SzBS
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  BinSearch, 0, addr SzTest1, 50, addr SzMatch1, 10
        mov     edi, eax
        counter_end
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBWL
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 10  ; matchlen
        mov     edx, 50  ; sourcelen
        lea     ecx, SzMatch1
        lea     ebp, SzTest1
        xor     ebx, ebx ; startpos
        invoke  BInStrWithLen
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMB
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  BMBinSearch, 0, addr SzTest1, 50, addr SzMatch1, 10
        mov     edi, eax
        counter_end
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBM2
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 10  ; matchlen
        mov     edx, 50  ; sourcelen
        lea     ecx, SzMatch1
        lea     ebp, SzTest1
        xor     ebx, ebx ; startpos
        invoke  BMBinSearch2
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMC
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  FJT, addr SzTest1, 50, addr SzMatch1, 10
        mov     edi, eax
        counter_end
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 10  ; matchlen
        mov     edx, 50  ; sourcelen
        lea     ecx, SzMatch1
        lea     ebp, SzTest1
        xor     ebx, ebx ; startpos
        invoke  FJT2
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzResult2

        print   addr SzBS
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  BinSearch, 0, addr SzTest2, 1024, addr SzMatch2, 17
        mov     edi, eax
        counter_end
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBWL
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 17  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch2
        lea     ebp, SzTest2
        xor     ebx, ebx ; startpos
        invoke  BInStrWithLen
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMB
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  BMBinSearch, 0, addr SzTest2, 1024, addr SzMatch2, 17
        mov     edi, eax
        counter_end
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBM2
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 17  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch2
        lea     ebp, SzTest2
        xor     ebx, ebx ; startpos
        invoke  BMBinSearch2
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMC
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  FJT, addr SzTest2, 1024, addr SzMatch2, 17
        mov     edi, eax
        counter_end
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 17  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch2
        lea     ebp, SzTest2
        xor     ebx, ebx ; startpos
        invoke  FJT2
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzResult3

        print   addr SzBS
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  BinSearch, 0, addr SzTest3, 1024, addr SzMatch3, 16
        mov     edi, eax
        counter_end
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBWL
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch3
        lea     ebp, SzTest3
        xor     ebx, ebx ; startpos
        invoke  BInStrWithLen
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMB
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  BMBinSearch, 0, addr SzTest3, 1024, addr SzMatch3, 16
        mov     edi, eax
        counter_end
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBM2
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch3
        lea     ebp, SzTest3
        xor     ebx, ebx ; startpos
        invoke  BMBinSearch2
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMC
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  FJT, addr SzTest3, 1024, addr SzMatch3, 16
        mov     edi, eax
        counter_end
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch3
        lea     ebp, SzTest3
        xor     ebx, ebx ; startpos
        invoke  FJT2
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzResult4

        print   addr SzBS
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  BinSearch, 0, addr SzTest4, 1024, addr SzMatch4, 16
        mov     edi, eax
        counter_end
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBWL
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch4
        lea     ebp, SzTest4
        xor     ebx, ebx ; startpos
        invoke  BInStrWithLen
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMB
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  BMBinSearch, 0, addr SzTest4, 1024, addr SzMatch4, 16
        mov     edi, eax
        counter_end
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBM2
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch4
        lea     ebp, SzTest4
        xor     ebx, ebx ; startpos
        invoke  BMBinSearch2
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMC
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  FJT, addr SzTest4, 1024, addr SzMatch4, 16
        mov     edi, eax
        counter_end
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch4
        lea     ebp, SzTest4
        xor     ebx, ebx ; startpos
        invoke  FJT2
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzResult5

        print   addr SzBS
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  BinSearch, 0, addr SzTest5, 1024, addr SzMatch5, 16
        mov     edi, eax
        counter_end
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBWL
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch5
        lea     ebp, SzTest5
        xor     ebx, ebx ; startpos
        invoke  BInStrWithLen
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMB
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  BMBinSearch, 0, addr SzTest5, 1024, addr SzMatch5, 16
        mov     edi, eax
        counter_end
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBM2
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch5
        lea     ebp, SzTest5
        xor     ebx, ebx ; startpos
        invoke  BMBinSearch2
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMC
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  FJT, addr SzTest5, 1024, addr SzMatch5, 16
        mov     edi, eax
        counter_end
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch5
        lea     ebp, SzTest5
        xor     ebx, ebx ; startpos
        invoke  FJT2
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzResult6

        print   addr SzBS
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  BinSearch, 0, addr SzTest6, 1024, addr SzMatch6, 16
        mov     edi, eax
        counter_end
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBWL
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch6
        lea     ebp, SzTest6
        xor     ebx, ebx ; startpos
        invoke  BInStrWithLen
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMB
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  BMBinSearch, 0, addr SzTest6, 1024, addr SzMatch6, 16
        mov     edi, eax
        counter_end
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBM2
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch6
        lea     ebp, SzTest6
        xor     ebx, ebx ; startpos
        invoke  BMBinSearch2
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMC
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  FJT, addr SzTest6, 1024, addr SzMatch6, 16
        mov     edi, eax
        counter_end
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch6
        lea     ebp, SzTest6
        xor     ebx, ebx ; startpos
        invoke  FJT2
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzResult7

        print   addr SzBS
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  BinSearch, 0, addr SzTest7, 1024, addr SzMatch7, 14
        mov     edi, eax
        counter_end
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBWL
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 14  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch7
        lea     ebp, SzTest7
        xor     ebx, ebx ; startpos
        invoke  BInStrWithLen
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMB
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  BMBinSearch, 0, addr SzTest7, 1024, addr SzMatch7, 14
        mov     edi, eax
        counter_end
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBM2
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 14  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch7
        lea     ebp, SzTest7
        xor     ebx, ebx ; startpos
        invoke  BMBinSearch2
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMC
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  FJT, addr SzTest7, 1024, addr SzMatch7, 14
        mov     edi, eax
        counter_end
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 14  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch7
        lea     ebp, SzTest7
        xor     ebx, ebx ; startpos
        invoke  FJT2
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10,13,10)
        invoke  Sleep, 250

        mov     eax, input(" Press ENTER to exit...")
        pop     edi
        pop     ebx
        ret

Main	EndP

; ------------------------------------------------------------------------------

Align 16

BinSearch proc startpos:DWORD,lpSource:DWORD,sLen:DWORD,lpPattern:DWORD,pLen:DWORD

    push ebx
    push esi
    push edi

  ; ----------------
  ; setup loop code
  ; ----------------
    mov esi, lpSource
    mov edi, lpPattern
    mov al, [edi]           ; get 1st char in pattern

    mov ecx, sLen
    sub ecx, pLen           ; sub pattern len to avoid searching past end of src
    add ecx, 1
    add esi, ecx            ; add source length
    neg ecx                 ; invert sign
    add ecx, startpos       ; add starting offset
    sub pLen, 1
    jmp Scan_Loop

  ; ----------------------------------------

  align 4
  Pre_Match:
    lea ebx, [esi+ecx]      ; put current scan address in EBX
    mov edx, pLen           ; put pattern length into EDX

  Test_Match:
    mov ah, [ebx+edx-1]     ; load last byte of pattern length in main string
    cmp ah, [edi+edx-1]     ; compare it with last byte in pattern
    jne Pre_Scan            ; exit loop on mismatch
    sub edx, 1
    jnz Test_Match

    jmp Match

  align 4
  Pre_Scan:
    add ecx, 1              ; start on next byte

  Scan_Loop:
    cmp al, [esi+ecx]       ; scan for 1st byte of pattern
    je Pre_Match            ; test if it matches
    add ecx, 1
    js Scan_Loop            ; exit on sign inversion

  ; ----------------------------------------
    
  No_Match:                 ; fall through here on no match
    mov eax, -1
    jmp isOut

  Match:
    add ecx, sLen
    sub ecx, pLen
    mov eax, ecx

  isOut:
    pop edi
    pop esi
    pop ebx

    ret

BinSearch endp

; ------------------------------------------------------------------------------

OPTION PROLOGUE:none
OPTION EPILOGUE:none

; 

align 4

BInStr    proc

 comment    * -----------------------------------------------------------------------------
            This finds the first occurrence of the null-terminated StrToFind in the byte
            array SourceArray. SourceLen is the length of the byte array (1-based).
            It returns the 0-based position if StrToFind is found, else -1 if not.

            By IanB.

            On entry:
                ECX = pointer to StrToFind
                EDX = SourceLen
                EBP = SourceArray
                EBX = StartPos
            On exit:
                EAX = string position (from start of SourceArray) or -1 if not found
                ECX = pointer to StrToFind
                EDX = length of StrToFind
            EBX/EBP/EDI/ESI are preserved.
            ----------------------------------------------------------------------------- *

        xor     eax, eax                ; EAX is string length counter

GetLengthLoop:
        add     eax, 1
        cmp     BYTE PTR [ecx+eax-1], 0 ; get next char from string
        jne     GetLengthLoop

        sub     eax, 1                  ; don't process zero-length strings
        jnz     BInStrWithLen           ; otherwise fall through to BInStrWithLen

        mov     edx, eax                ; copy string length
        not     eax                     ; unsuccessful return value
        ret

BInStr    endp

; 

Align 16

BInStrWithLen    proc

 comment    * -----------------------------------------------------------------------------
            This entry point allows us to set the string length manually if we know it,
            and thus to specify strings with null characters embedded.

            By matching two characters at a time we should reduce the number of false
            positive matches testing only for a single first char would give, plus we can
            test whole aligned DWORDs at a time for greater speed.

            By IanB.

            On entry:
                EAX = length of StrToFind (must be >= 2)
                ECX = pointer to StrToFind
                EDX = SourceLen
                EBP = SourceArray
                EBX = StartPos
            On exit:
                EAX = string position (from start of SourceArray) or -1 if not found
                ECX = pointer to StrToFind
                EDX = length of StrToFind
            EBX/EBP/EDI/ESI are preserved.
            ----------------------------------------------------------------------------- *

        sub     edx, eax                ; last valid array position to test
        jb      BInStrError             ; test string is longer than array
        cmp     eax, 2
        jb      BInStrError             ; test string must have minimum length of 2 chars
        cmp     edx, ebx
        jb      BInStrError             ; start position + stringlength beyond end of array

        push    edi                     ; save registers
        push    esi
        push    ebx
        push    ebp

        movzx   edi, WORD PTR [ecx]     ; get first 2 string characters
        add     ebx, ebp                ; get start pointer
        add     ebp, edx                ; EBP holds last valid position pointer
        push    ecx                     ; save StrToFind
        push    eax                     ; save stringlength
        push    ebx                     ; save start pointer
        push    edi                     ; save even-aligned offset match
        shl     edi, 8                  ; get odd-aligned offset match

FindFirstChars:
        mov     ecx, [ebx]              ; read first 4 bytes
        mov     esi, ebx
        mov     edx, [esp]              ; retrieve even-aligned offset match
                                        ; keep value on stack
        mov     eax, 4
        and     esi, 3H                 ; check if start is DWORD aligned
        jz      @F
        cmp     ebp, ebx                ; have we read past the last valid position?
        jb      StringNotFound
        sub     eax, esi                ; otherwise check first non-aligned words

        mov     esi, ecx
        cmp     cx, dx
        je      StartCheckString
        add     ebx, 1
        sub     eax, 1
        jz      FindCharsDWLoop

        and     esi, 0ffff00H
        shr     ecx, 16
        cmp     ebp, ebx                ; have we read past the last valid position?
        jb      StringNotFound
        cmp     esi, edi
        je      StartCheckString
        add     ebx, 1
        sub     eax, 1
        jz      FindCharsDWLoop

        cmp     ebp, ebx                ; have we read past the last valid position?
        jb      StringNotFound
        cmp     cx, dx
        je      StartCheckString
        add     ebx, eax                ; EAX = 1
        xor     eax, eax

align 4

FindCharsDWLoop:
        mov     ecx, [ebx]              ; read next 4 bytes

align 4

@@:
        cmp     ebp, ebx                ; have we read past the last valid position?
        jb      StringNotFound
        cmp     cx, dx
        je      StartCheckString

        mov     eax, ecx
        mov     esi, ecx
        shr     eax, 16
        mov     ecx, [ebx+4]            ; read next 4 bytes
        and     esi, 0ffff00H
        add     ebx, 4
        cmp     esi, edi
        je      FirstOdd
        cmp     ax, dx
        je      SecondEven
        cmp     ah, dl                  ; test last byte
        jne     @B

        cmp     cl, dh                  ; test next byte
        jne     @B
        sub     ebx, 1
        jmp     @F

SecondEven:
        sub     ebx, 2
        jmp     @F

FirstOdd:
        sub     ebx, 3
@@:
        xor     eax, eax
        cmp     ebp, ebx                ; have we read past the last valid position?
        jb      StringNotFound

align 4

StartCheckString:
        mov     esi, [esp+8]            ; retrieve stringlength
        mov     ecx, 2                  ; set stringlength counter
        mov     edx, [esp+12]           ; retrieve StrToFind pointer
        sub     esi, ecx
        je      StringFound

align 4

@@:
        mov     eax, [ebx+ecx]          ; get next 4 string chars
        add     ecx, 4
        sub     esi, 4                  ; have we matched all the chars in the string?
        jb      CheckLastBytes
        jz      CheckLastDWORD
        cmp     [edx+ecx-4], eax
        jne     StringNotMatched
        jmp     @B

CheckLastBytes:
        cmp     BYTE PTR [edx+ecx-4], al
        jne     StringNotMatched
        add     esi, 3
        jz      StringFound
        cmp     BYTE PTR [edx+ecx-3], ah
        jne     StringNotMatched
        shr     eax, 16
        sub     esi, 1
        jz      StringFound
        cmp     BYTE PTR [edx+ecx-2], al
        je      StringFound

StringNotMatched:
        add     ebx, 1                  ; start again from next char position
        jmp     FindFirstChars

StringNotFound:
        xor     eax, eax
        mov     ebx, 1
        pop     edx                     ; dump mask value
        pop     ecx                     ; dump start pointer
        jmp     @F

CheckLastDWORD:
        cmp     [edx+ecx-4], eax
        jne     StringNotMatched

StringFound:
        mov     eax, ebx
        pop     ecx                     ; dump mask value
        pop     ebx                     ; retrieve start pointer
@@:
        pop     edx                     ; retrieve stringlength
        pop     ecx                     ; retrieve StrToFind pointer
        sub     eax, ebx                ; get offset of found string as return value
                                        ; or -1 if not found
        pop     ebp                     ; restore registers
        pop     ebx
        pop     esi
        pop     edi
        ret

BInStrError:
        mov     edx, eax                ; copy string length
        or      eax, MINUS_1            ; unsuccessful return value
        ret

BInStrWithLen    endp

OPTION PROLOGUE:PROLOGUEDEF 
OPTION EPILOGUE:EPILOGUEDEF

; ------------------------------------------------------------------------------

Align 16

BMBinSearch proc startpos:DWORD,
                 lpSource:DWORD,srcLngth:DWORD,
                 lpSubStr:DWORD,subLngth:DWORD

  ; -----------------------------------------------------------------
  ; This version uses four heuristics, it determines the shift type
  ; from the character in the table, if the character is not in the
  ; pattern, it performs a BAD CHARACTER shift, if the character is
  ; in the pattern, it determines if it is the first comparison after
  ; the shift and adds the GOOD SUFFIX shift to the location counter.
  ; If the comparison is not the first after the shift, it calculates
  ; the GOOD SUFFIX shift and adds it to the location counter.
  ; -----------------------------------------------------------------

    LOCAL cval   :DWORD
    LOCAL shift_table[256]:DWORD

    push ebx
    push esi
    push edi

    mov ebx, subLngth

    cmp ebx, 1
    jg @F
    mov eax, -2                 ; string too short, must be > 1
    jmp Cleanup
  @@:

    mov esi, lpSource
    add esi, srcLngth
    sub esi, ebx
    mov edx, esi            ; set Exit Length

  ; ----------------------------------------
  ; load shift table with value in subLngth
  ; ----------------------------------------
    mov ecx, 256
    mov eax, ebx
    lea edi, shift_table
    rep stosd

  ; ----------------------------------------------
  ; load decending count values into shift table
  ; ----------------------------------------------
    mov ecx, ebx                ; SubString length in ECX
    dec ecx                     ; correct for zero based index
    mov esi, lpSubStr           ; address of SubString in ESI
    lea edi, shift_table

    xor eax, eax

  Write_Shift_Chars:
    mov al, [esi]               ; get the character
    inc esi
    mov [edi+eax*4], ecx        ; write shift for each character
    dec ecx                     ; to ascii location in table
    jnz Write_Shift_Chars

  ; -----------------------------
  ; set up for main compare loop
  ; -----------------------------
    mov ecx, ebx
    dec ecx
    mov cval, ecx

    mov esi, lpSource
    mov edi, lpSubStr
    add esi, startpos           ; add starting position

    jmp Pre_Loop

; %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Calc_Suffix_Shift:
    add eax, ecx
    sub eax, cval               ; sub loop count
    jns Add_Suffix_Shift
    mov eax, 1                  ; minimum shift is 1

  Add_Suffix_Shift:
    add esi, eax                ; add SUFFIX shift
    mov ecx, cval               ; reset counter in compare loop

  Test_Length:
    cmp edx, esi                ; test exit condition
    jl No_Match

  Pre_Loop:
    xor eax, eax                ; zero EAX for following partial writes
    mov al, [esi+ecx]
    cmp al, [edi+ecx]           ; cmp characters in ESI / EDI
    je @F
    mov eax, shift_table[eax*4]
    cmp ebx, eax
    jne Add_Suffix_Shift        ; bypass SUFFIX calculations
    lea esi, [esi+ecx+1]        ; add BAD CHAR shift
    jmp Test_Length
  @@:
    dec ecx
    xor eax, eax                ; zero EAX for following partial writes

  Cmp_Loop:
    mov al, [esi+ecx]
    cmp al, [edi+ecx]           ; cmp characters in ESI / EDI
    jne Set_Shift               ; if not equal, get next shift
    dec ecx
    jns Cmp_Loop
    jmp Match                   ; fall through on match

  Set_Shift:
    mov eax, shift_table[eax*4]
    cmp ebx, eax
    jne Calc_Suffix_Shift       ; run SUFFIX calculations
    lea esi, [esi+ecx+1]        ; add BAD CHAR shift
    jmp Test_Length

; %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Match:
    sub esi, lpSource           ; sub source from ESI
    mov eax, esi                ; put length in eax
    jmp Cleanup

  No_Match:
    mov eax, -1

  Cleanup:
    pop edi
    pop esi
    pop ebx

    ret

BMBinSearch endp

; ------------------------------------------------------------------------------

Align 16

OPTION PROLOGUE:none
OPTION EPILOGUE:none

BMBinSearch2 proc

 comment    * -----------------------------------------------------------------------------
            BMBinSearch rewritten by IanB to use the same entry and exit protocols as
            BInStrWithLen, plus a general tune-up improving speed by up to 25%, including
            the use of the .DATA? section for the ShiftTable, as using a stack-based table
            almost wiped out the speed gains in my testing. Also restricted search string
            to 256 chars, allowing byte-length shifts and a 256-byte shift table.

            On entry:
                EAX = length of StrToFind (must be >= 2 and < 256)
                ECX = pointer to StrToFind
                EDX = SourceLen
                EBP = SourceArray
                EBX = StartPos
            On exit:
                EAX = string position (from start of SourceArray) or -1 if not found
                EDX = length of StrToFind
            EBX/EBP/EDI/ESI are preserved.
            ----------------------------------------------------------------------------- *

    push esi
    push edi
    push eax
    push ebx

    cmp eax, 2              ; string too short, must be > 1
    jb  Bad_Param
    cmp eax, 255            ; string too long, must be < 256
    ja  Bad_Param

    push ebp
    add edx, ebp
    mov esi, ecx            ; address of SubString in ESI
    add ebp, ebx            ; add starting position
    sub edx, eax            ; set Exit Length

  ; ----------------------------------------
  ; load shift table with value in subLngth
  ; ----------------------------------------
    lea edi, ShiftTable
    mov ecx, 256
    rep stosb

  ; ----------------------------------------------
  ; load decending count values into shift table
  ; ----------------------------------------------
    mov ebx, eax                ; SubString length in EBX
    mov edi, esi
    sub eax, 1                  ; correct for zero based index

  Write_Shift_Chars:
    movzx ecx, BYTE PTR [edi]   ; get the character
    add edi, 1
    mov ShiftTable[ecx], al     ; write shift for each character
    sub al, 1                   ; to ascii location in table
    jnz Write_Shift_Chars

  ; -----------------------------
  ; set up for main compare loop
  ; -----------------------------
    movzx ecx, BYTE PTR [ebp+ebx-1]
    lea edi, [ebx-1]
    add eax, ebp                ; this register is basis for output value
    jmp Pre_Loop

; %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Calc_Suffix_Shift:
    add ecx, ebp
    sub ecx, ebx                ; sub loop count
    jbe Set_Minimum_Shift

  Add_Suffix_Shift:
    sub edi, ebp                ; EDI = -1
    add eax, ecx                ; add SUFFIX shift
    add edi, ebx                ; reset counter in compare loop

  Test_Length:
    movzx ecx, BYTE PTR [eax+edi]
    cmp eax, edx                ; test exit condition
    ja No_Match

  Pre_Loop:
    cmp cl, [esi+edi]           ; cmp characters in EAX / ESI
    je @F
    movzx ecx, BYTE PTR ShiftTable[ecx]
    lea ebp, [edi+1]
    cmp ebx, ecx
    jne Add_Suffix_Shift        ; bypass SUFFIX calculations
    add eax, ebp                ; add BAD CHAR shift
    jmp Test_Length

  Cmp_Loop:
    cmp cl, [esi+edi]           ; cmp characters in EAX / ESI
    jne Set_Shift               ; if not equal, get next shift
  @@:
    movzx ecx, BYTE PTR [eax+edi-1]
    sub edi, 1
    jns Cmp_Loop
    jmp Match                   ; fall through on match

  Set_Shift:
    movzx ecx, BYTE PTR ShiftTable[ecx]
    lea ebp, [edi+1]
    cmp ebx, ecx
    jne Calc_Suffix_Shift       ; run SUFFIX calculations
    add eax, ebp                ; add BAD CHAR shift
    jmp Test_Length

  Set_Minimum_Shift:
    mov ecx, 1                  ; minimum shift is 1
    jmp Add_Suffix_Shift

; %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  Match:
    pop ebp
    sub eax, ebp                ; put length in eax
    jmp Cleanup

  No_Match:
    pop ebp

  Bad_Param:
    or  eax, MINUS_1

  Cleanup:
    pop ebx
    pop edx
    pop edi
    pop esi

    ret

BMBinSearch2 endp


; ------------------------------------------------------------------------------

align 16

;============ * BM by Cresta * =====================

FJT	proc	lpData:DWORD, DataLen:DWORD, lpMatch:DWORD, match_len:DWORD

	push	ebx
	push	ebp
	push	esi
	push	edi
	sub	esp,1024                    	;LOCAL forward_tbl[256]          :DWORD
    
	mov	ecx,256
	mov	edx,dword ptr [esp+1056]    	;match_len
	inc	edx
	dec	ecx
   
fill:  						;--  < d+1>   256 d 
	mov	[esp+ecx*4],edx
	dec	ecx
	jns	fill
    
	dec	edx				;edx=match_len
	xor	ecx,ecx
	mov	edi,dword ptr [esp+1052]	;lpMatch

put_offset:		;--    a ,  d   esi
	movzx	eax, byte ptr[edi+ecx]	;  d d
	mov	[esp+eax*4],edx             	; a      ya 
	sub	dword ptr[esp+eax*4],ecx	; + < d>
	inc	ecx
	cmp	ecx,edx
	jne	put_offset
end_put:                        ;   :
                                    ; 16-   esi (esi+16)  o  d,
                                    ;   +17
                                    ; 16-   esi (esi+16) o  d
                                    ;   0 - . = +16 (add esi,16)
                                    ;   1 - . = +15 (add esi,15)
                                    ;...................................
                                    ;  14 - . =  +2 (add esi,2)
                                    ;  15 - . =  +1 (add esi,1)
    
	mov	esi,dword ptr [esp+1044]    	;esi=lpData
	mov	ebx,esi
	add	ebx,dword ptr [esp+1048]    	;ebx=lpData+DataLen
	sub	ebx,edx                     	;ebx=lpData+DataLen-match_len
	inc	ebx                         	;d d,  da 
    
	mov	ebp,edx                     	;dword ptr [esp+1056]=match_len
        
scan: 
	mov	edx,ebp                     	;edx = <bytes's count>
	shr	edx,2                       	;edx = <dword's count>
	dec	edx                         	;edx = <dword's count - 1>
	mov	ecx,edx                     	;ecx = <dword's count - 1>
align 4    
first_dword:                       			; d
	mov	eax,[esi]                   	;d d
	cmp	eax,[edi]                   	;  - d d
	jne	@F                          	;  a
align 4
scan_dword:
	mov	eax,[esi+edx*4]             	;dd  d esi...esi+match_len     
	cmp	eax,[edi+edx*4]             	;d  
	jne	@F                          	;   - d   d
	dec	edx                         	;     1 d
	js	last_bytes                   	;   a - do  dd oo 
	mov	eax,[esi+edx*4]             	;    a, d
	cmp	eax,[edi+edx*4]
	jne	@F
	dec	edx
	js	last_bytes
	mov	eax,[esi+edx*4]
	cmp	eax,[edi+edx*4]
	jne	@F
	dec	edx
	js	last_bytes
	mov	eax,[esi+edx*4]
	cmp	eax,[edi+edx*4]
	jne	@F
	dec	edx
	js	last_bytes
	jmp	scan_dword
align 4 
 @@:                                		; do  esi...esi+match_len d _ d
	movzx	eax, byte ptr[esi+ebp]	;d  esi+match_len     a o  d
	add	esi,[esp+eax*4]             	; o_ ya  ddd esi
	cmp	esi,ebx                     	;  dd esi  d d d,
	mov	edx,ecx                     	;  edx  ecx - o d
	jle	first_dword                 	;d   esi  d_.

  ;--   .
no_match:
	or	eax,-1
	jmp	@Ret
last_bytes:                         				;  d   esi   d
	inc	ecx                         	;ecx - - d  d
	mov	edx,dword ptr [esp+1056]    	;edx -  d  o
	shl	ecx,2                       	;ecx -  ddo 
	sub	edx,ecx                     	;edx - - , oo dd (0...3)
	add	esi,ecx                     	;a esi  edi  o dd
	add	edi,ecx                     	; d  a esi.
 @@:
	dec	edx                         	;dd oo  
	js	found                        	; dd  -  o
	mov	al,byte ptr[esi+edx]
	cmp	byte ptr[edi+edx],al
	je	@B
	sub	esi,ecx			; ,    o   
	sub	edi,ecx			; esi  edi     d
	inc	esi				;a   1 
	jmp	scan				;d .
    
found:                             		 		;   d  .
	sub	esi,ecx
	mov	eax,esi
	sub	eax,dword ptr [esp+1044]    	;lpData
@Ret:
	add	esp,1024
	pop	edi
	pop	esi
	pop	ebp
	pop	ebx
	retn	16                         	;return file offset of substring or -1 if not found

FJT endp

; ------------------------------------------------------------------------------

align 16

FJT2	proc

 comment    * -----------------------------------------------------------------------------
            BM by Cresta rewritten by IanB to use the same entry and exit protocols as
            BInStrWithLen, optimisations including the use of the .DATA? section for the
            ShiftTable, as the extra indexing is slower. Also restricted search string
            to 255 chars, allowing byte-length shifts and a 256-byte shift table.

            On entry:
                EAX = match_len (must be >= 2 and < 255)
                ECX = lpMatch, pointer to test string
                EDX = DataLen
                EBP = lpData, pointer to source array
                EBX = StartPos offset in lpData
            On exit:
                EAX = string position (from start of source array) or -1 if not found
                EDX = match_len
            EBX/EBP/EDI/ESI are preserved.
            ----------------------------------------------------------------------------- *

        push    esi
        push    edi
        push    eax
        push    ebx
        push    ebp

        cmp     eax, 2                  ; string too short, must be > 1
        jb      no_match
        cmp     eax, 254                ; string too long, must be < 254
        ja      no_match

        add	    edx, ebp
        add     ebp, ebx                ; EBP = lpData (including startpos offset if any)
        lea     edi, ShiftTable
        mov     ebx, eax                ; EBX = match_len
        sub	    edx, eax
        add     eax, 1
        mov     esi, ecx                ; ESI = lpMatch
        and     ebx, 0fffffffcH         ; remove remainder bytes over DWORD count
        add     edx, 1                  ; EDX = lpData+DataLen-match_len+1
        mov     ecx, 256
        rep     stosb                   ; fill ShiftTable with match_len+1

        mov     edi, esi
        sub     eax, 1                  ; EAX = match_len
        sub     ebx, 4                  ; EBX = 4 * (count of DWORDs in match string - 1)

put_offset:
        movzx   ecx, BYTE PTR [edi]
        add     edi, 1
        mov     ShiftTable[ecx], al
        sub     al, 1
        jnz     put_offset

        mov     eax, [esi]              ; get first DWORD to compare
        mov     edi, ebp                ; EDI = lpData + startpos
        mov     ebp, [esp+8]            ; EBP = match_len
        push    ebx                     ; save DWORD counter

align 4    

first_dword:
        movzx   ecx, BYTE PTR [edi+ebp]
        cmp     eax, [edi]
        jne     @F

align 4

scan_dword:
        mov     eax, [edi+ebx]
        cmp     eax, [esi+ebx]
        jne     @F
        sub     ebx, 4
        js      last_bytes
        mov     eax, [edi+ebx]
        cmp     eax, [esi+ebx]
        jne     @F
        sub     ebx, 4
        js      last_bytes
        mov     eax, [edi+ebx]
        cmp     eax, [esi+ebx]
        jne     @F
        sub     ebx, 4
        js      last_bytes
        mov     eax, [edi+ebx]
        cmp     eax, [esi+ebx]
        jne     @F
        sub     ebx, 4
        js      last_bytes
        jmp     scan_dword

align 4 

@@:
        movzx   ecx, ShiftTable[ecx]
        mov     eax, [esi]              ; get first DWORD to compare
        add     edi, ecx
        mov     ebx, [esp]              ; restore DWORD counter
        cmp     edi, edx                ; check for end of data
        jle     first_dword

no_match:
        or      eax, MINUS_1
        pop     ecx                     ; dump DWORD count
        pop     ebp
        jmp     @Ret

last_bytes:
        mov     ecx, 0fffffffcH
        mov     ebx, ebp
        and     ecx, ebp
        sub     ebx, ecx                ; match_len - whole DWORDs matched so far
        add     esi, ecx
        add     edi, ecx
@@:
        mov     al, BYTE PTR [esi+ebx-1]
        sub     ebx, 1
        js      found
        cmp     [edi+ebx], al
        je      @B

        sub     edi, ecx
        sub     esi, ecx
        add     edi, 1
        mov     eax, [esi]              ; get first DWORD to compare
        mov     ebx, [esp]              ; restore DWORD counter
        jmp     first_dword
    
found:
        pop     edx                     ; dump DWORD count
        sub     edi, ecx
        pop     ebp
        mov     eax, edi
        sub     eax, ebp
@Ret:
        pop     ebx
        pop     edx                     ; return match_len in EDX
        pop     edi
        pop     esi
        ret                             ; return offset of string or -1 if not found

FJT2 endp

OPTION PROLOGUE:PROLOGUEDEF 
OPTION EPILOGUE:EPILOGUEDEF

; ------------------------------------------------------------------------------

End	Start
